<?php

class YResilience_Frontend {

	static $instance = false;

	public static function init() {
		if ( ! self::$instance ) {
			self::$instance = new YResilience_Frontend;
		}
		return self::$instance;
	}

	public function __construct() {
		$this->has_run = false;
		add_action( 'wp_footer' , array( $this, 'insert_init_js' ) );
    add_action('template_redirect', array( $this, 'proxy') );
	}

	public function insert_init_js() {
		if ( $this->has_run ) return;
		$this->has_run = true;

		$dopush = get_query_var( 'exact', '' );
		if (strstr($dopush, 'yavlipush')) {
			$hb = YResilience_Heartbeat::init();
			$result = $hb->push_update();
			$last_error_msg = YResilience_Options::get_option( 'last_error_msg' );
			$msg = 'YR push, ';
			if ( $result == true ) {
				$msg .= 'updated: yes.';
			} else {
				$msg .= 'updated: no.';
			}
			if ( $last_error_msg != '' ) {
				$msg .= ' Last error msg: ' . $last_error_msg;
			}
			echo "\n\n<!-- " . esc_html($msg) . " -->\n\n";
		}

		$init_js = YResilience_Options::get_option( 'init_js' );
		if ( !empty( $init_js ) && YResilience_Options::get_option( 'enabled' ) == 1) {
			echo $init_js . "\n";
		}
	}
  
  public function proxy(){
    global $wp_query;
    //echo 'ok';
    $uri=$_SERVER['REQUEST_URI'];
    //var_dump($wp_query->is_404);
    if($wp_query->is_404 && preg_match('/(.*\.(|jpg|jpeg|gif|png|js|css))/i',$uri)){
    //echo 'ok';
      $default_args = array(
  			'timeout'     => 5,
  			'redirection' => 5,
  			'httpversion' => '1.1',
  			'user-agent'  => 'WordPress/ ' . get_bloginfo( 'url' ),
  			'blocking'    => true,
  			'headers'     => array(
    			'X-Forwarded-For'  => $_SERVER['REMOTE_ADDR'],
			    'X-Forwarded-Host' => $_SERVER['HTTP_HOST'],
    		),
  			'cookies'     => $_COOKIE,
  			'body'        => null,
  			'compress'    => false,
  			'decompress'  => true,
  			'sslverify'   => true,
  			'stream'      => false,
  			'filename'    => null
  		);
  		$args = array_merge( $default_args);
      $url = 'http://steg.yavli.com'.$uri;
       
      //if ( $this->is_wp_vip ) {
  		//	$response = vip_safe_wp_remote_get( $url, $fallback_value='', $threshold = 3, $timeout = 2, $retry = 20, $args );
  		//}else{
        $response = wp_remote_get( $url, $args );
      //}
      
      if( is_wp_error( $response ) ) {
        return false;
      }
      //exit('ok');
      
      //var_dump($response);
      //exit();
      if($response["response"]['code']==200){
        $wp_query->is_404=false;
        header("HTTP/1.1 200 OK");
        foreach($response['headers'] as $k=>$v){
          header($k.': '.$v);
        }
        echo $response['body'];
        exit();
      }

      
      
    }
  }
}
