<?php
/*
 * Plugin Name: Yavli Resilience
 * Plugin URI: http://yavli.com/yavli-wordpress-plugin
 * Description: Resilient Advertising For Your Website
 * Author: Yavli
 * Version: 2.1.3
 * License: GPL2+
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

require_once( ABSPATH . 'wp-admin/includes/file.php' );
require_once( ABSPATH . 'wp-includes/pluggable.php' );

define( 'YRESILIENCE_VERSION', '2.1.3' );
define( 'YRESILIENCE_VERSION_TRACE', 'bb' );
define( 'YRESILIENCE_URL', plugins_url( '', __FILE__ ) );
define( 'YRESILIENCE_PLUGIN_PATH', __DIR__ . '/');
define( 'YRESILIENCE_PLUGIN_DIR', plugin_dir_path( __FILE__ ) );
define( 'YRESILIENCE_PLUGIN_BASENAME', plugin_basename( __FILE__ ) );
define( 'YRESILIENCE_PLUGIN_PREFIX', 'yavli-resilience' );
define( 'YRESILIENCE_PLUGIN_ADMIN_PAGE', 'yresilience_admin_page' );

require_once( YRESILIENCE_PLUGIN_DIR . 'class.yresilience.php' );
require_once( YRESILIENCE_PLUGIN_DIR . 'class.yresilience-options.php' );
require_once( YRESILIENCE_PLUGIN_DIR . 'class.yresilience-api.php' );

require_once( YRESILIENCE_PLUGIN_DIR . 'class.yresilience-heartbeat.php' );
YResilience_Heartbeat::init();

if (is_admin() ) {
	require_once( YRESILIENCE_PLUGIN_DIR . 'class.yresilience-admin.php' );
	YResilience_Admin::init();
} else {
	require_once( YRESILIENCE_PLUGIN_DIR . 'class.yresilience-frontend.php' );
	YResilience_Frontend::init();
}

register_activation_hook( __FILE__, array( 'YResilience', 'plugin_activation' ) );
register_deactivation_hook( __FILE__, array( 'YResilience', 'plugin_deactivation' ) );
